> For the complete documentation index, see [llms.txt](https://docs.redivis.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.redivis.com/api/rest-api/uploads/insertrows.md).

# insertRows

## Overview

This endpoint can be used for streaming a small number of rows into a table at high frequency. For bulk uploading a large number of records, use the upload post interface. &#x20;

## HTTP Request

```http
POST /api/v1/tables/:tableReference/uploads/:uploadName/rows
```

## Path parameters

| Parameter      | Description                                                                                                                                    |
| -------------- | ---------------------------------------------------------------------------------------------------------------------------------------------- |
| tableReference | A qualified reference to the table. See [referencing resources](/api/referencing-resources.md) for more information.                           |
| uploadName     | The name of the upload. Make sure to [URL encode](https://en.wikipedia.org/wiki/URL_encoding) the name if it contains any reserved characters. |

{% hint style="info" %}
This endpoint extends the [general API structure](/api/rest-api/general-structure.md)
{% endhint %}

## Request body

Provide a JSON object with information about the table.

<table><thead><tr><th width="153.09375">Property name</th><th width="170.22005208333331">Type</th><th>Description</th></tr></thead><tbody><tr><td><strong>rows</strong></td><td>Array[Object]</td><td><p><strong>Required.</strong> An array of rows, where each row is an object whose keys represent the variable name and values represent that row's value for the given variable.</p><p></p><p>Note that booleans, integers, and floats must be expressed as their JSON types, not as strings. Date, DateTime, and Time types should use the canonical string representation (e.g., <code>1970-01-01T00:00:00.000</code>). Geographies must be expressed as WKT encoded strings (e.g., <code>POINT(10 20)</code>).</p><p></p><p>The overall payload cannot exceed 100MB. </p><p></p><p>E.g.: </p><pre><code>[
  { 
    "name": "Jane", 
    "age": 30 
  },
  {
    "name": "John", 
    "age": 5 
  },
  ...
]
</code></pre><p></p><p></p></td></tr></tbody></table>

## Authorization

Edit access to the dataset is required. Your access token must have the following scope:

* data.edit

[Learn more about authorization.](/api/rest-api/authorization.md)

## Response body

If successful, returns the following payload with a status code of 201.

```json5
{
  "kind": "insertRowsResponse",
  "rowsAdded": int
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.redivis.com/api/rest-api/uploads/insertrows.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
